<template>
    <div class="col-xs-12">
        <h1 v-if="imports">Edit supplier</h1>
        <h1 v-else>Add supplier</h1>

        <div class="clearfix">
            <ul class="nav nav-tabs">
                <li class="active" v-bind:class="{active:details}">
                    <a href="#" @click="activateTab('details', $event)">Supplier details</a>
                </li>
                <li v-bind:class="{active:settings}">
                    <a href="#" @click="activateTab('settings', $event)">Import settings</a>
                </li>
                <li v-bind:class="{active:stock}">
                    <a href="#" @click="activateTab('stock', $event)">Supplier stock</a>
                </li>
            </ul>
        </div>

        <div class="details" v-if="details">
            <h2>Details</h2>
            <div class="col-xs-12 form-horizontal">
                <div class="form-group">
                    <label>Company name</label>
                    <input type="text" v-model="supplier.name" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Email</label>
                    <input type="email" v-model="supplier.email" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Phone</label>
                    <input type="tel" v-model="supplier.phone" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Fax</label>
                    <input type="tel" v-model="supplier.fax" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>VAT number</label>
                    <input type="text" v-model="supplier.vat_number" class="form-control"/>
                </div>

                <h3>Address</h3>
                <div class="form-group">
                    <label>Street:</label>
                    <input type="text" v-model="supplier.address.street" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>City:</label>
                    <input type="text" v-model="supplier.address.city" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Country:</label>
                    <select v-model="supplier.address.country">
                        <option v-for="country in countries" v-bind:value="country.code">{{country.name}}</option>
                    </select>
                </div>
                <div class="form-group">
                    <label>Post code:</label>
                    <input type="text" v-model="supplier.address.post_code" class="form-control"/>
                </div>

                <h3>Contact person</h3>
                <div class="form-group">
                    <label>Name:</label>
                    <input type="text" v-model="supplier.contact_person.name" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Surname:</label>
                    <input type="text" v-model="supplier.contact_person.surname" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Middle name:</label>
                    <input type="text" v-model="supplier.contact_person.middle_name" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Email:</label>
                    <input type="email" v-model="supplier.contact_person.email" class="form-control"/>
                </div>

                <div class="form-group">
                    <label>Minimal order amount:</label>
                    <input type="number" v-model="supplier.min_order_amount.qty" class="form-control"/>
                    <select v-model="supplier.min_order_amount.type">
                        <option value="price">Per price</option>
                        <option value="item">Per items</option>
                    </select>
                </div>
                <div class="form-group">
                    <label>Status</label>
                    <input type="checkbox" v-model="supplier.status" :checked="false" class="form-control"/>
                </div>

                <div class="col-sm-12">
                    <span class="btn btn-default custom-attrs-form__save" @click="saveSupplier()">Save</span>
                    <span class="btn btn-danger repeater__button--delete" @click="deleteSupplier()">Delete</span>
                </div>
            </div>
        </div>

        <div class="settings" v-if="settings">
            <h2>Import settings</h2>
        </div>

        <div class="stock" v-if="stock">
            <h2>Stock</h2>
            <table></table>
        </div>
    </div>
</template>
<style>
</style>
<script>
    import $ from 'jquery';
    import 'jquery-ui';
    import 'jquery-ui/themes/base/base.css';
    import 'jquery-ui/themes/base/theme.css';
    import 'jquery-ui/themes/base/datepicker.css';
    import 'jquery-ui/ui/widgets/datepicker';
    import dt from 'datatables.net';
    import 'datatables.net-dt/css/jquery.dataTables.css'
    import 'yadcf';
    import moment from 'moment';

    dt(window, $);
    export default{
        data: function () {
            return {
                details: true,
                stock: false,
                settings: false,
                columns: [],
                options: {},
                yadcf_columns: [],
                countries: [],
                supplier: {
                    address: {},
                    contact_person: {},
                    min_order_amount: {},
                    imports: {}
                }
            }
        },
        route: {
            data(transition) {
                var id = this.$route.params.id;
                if (id != undefined) {
                    return this.$http.get('/api/v1/suppliers/supplier/' + id).then(function (res) {
//						console.log(res);
                        this.supplier = res.data;
                        console.log(this.supplier);
                        return {
                            supplier: res.data
                        }
                    });
                }
            }
        },
        ready: function () {
            this.getCountries().then(function (res) {
                this.countries = res;
            });
        },
        methods: {
            activateTab: function (tab, event) {
                event.preventDefault();
                if (tab == 'details') {
                    this.stock = false;
                    this.settings = false;
                    this.details = true;
                } else if (tab == 'settings') {
                    this.stock = false;
                    this.details = false;
                    this.settings = true;
                } else {
                    this.details = false;
                    this.settings = false;
                    this.stock = true;
                    this.getColumns().then(function (res) {
                        var self = this;
                        res.forEach(function (column, index) {
                            var element = {};
                            if (column.system) {
                                element = {
                                    data: column.code,
                                    title: column.name
                                }
                                if (column.code === 'name') {
                                    element.render = function (data, type, row) {
                                        return '<a href="#!/product/' + row._id + '">' + data + '</a>';
                                    }
                                }
                                if (column.type === 'date') {
                                    element.render = function (data, type, row) {
                                        return moment(data).format('YYYY-MM-DD hh:mm:ss');
                                    }
                                }
                            } else {
                                element = {
                                    "data": "attributes." + column.code,
                                    "title": column.name
                                }
                            }

                            var yadcf_element = {
                                column_number: index,
                                filter_type: column.type
                            }
                            if (column.type === 'date') {
                                var datetimepickerOptions = {
                                    timeFormat: 'HH:MM:SS',
                                    dateFormat: 'yy-mm-dd',
                                    timeInput: true
                                };
                                yadcf_element.datepicker_type = 'jquery-ui';
                                yadcf_element.date_format = 'yyyy-mm-dd HH:MM:SS';
                                yadcf_element.moment_date_format = 'YYYY-MM-DD hh:mm:ss';
                                yadcf_element.filter_plugin_options = datetimepickerOptions;
                            }
//					console.log(element);
                            self.columns.push(element);
                            self.yadcf_columns.push(yadcf_element);
                        });
//				console.log(this.columns);
                        this.buildDt();
                    });
                }
            },
            deleteSupplier: function () {
                if (this.supplier.id) {
                    this.$http.delete('/api/v1/suppliers/delete/' + this.supplier.id).then(function (res) {
                        console.log(res.data);
                    });
                }
            },
            saveSupplier: function () {
                if (this.supplier.id) {
                    this.$http.put('/api/v1/suppliers/update/' + this.supplier.id, this.supplier).then(function (res) {
                        console.log(res.data);
                    })
                } else {
                    this.$http.post('/api/v1/suppliers/create', this.supplier).then(function (res) {
                        console.log(res.data);
                    })
                }
            },
            getCountries: function () {
                return this.$http.get('/api/v1/settings/countries').then(function (res) {
                    return res.data.data
                })
            },
            getColumns: function () {
                return this.$http.get('/api/v1/product-attributes/get-columns').then(function (res) {
                    return res.data;
                })
            },
            buildDt: function () {
                self = this;
                this.options = {
                    processing: true,
                    serverSide: true,
                    lengthMenu: [[25, 50, 100, 200], [25, 50, 100, 200]],
                    ajax: {
                        url: '/api/v1/products',
                        data: function (d) {
                            d.columnsCount = self.columns.length,
                                d.type = 'supplier',
                                d.id = self.$route.params.id
                        }
                    },
                    columns: self.columns
                }
                var datatable = $('table').DataTable(this.options);

                yadcf.init(datatable, this.yadcf_columns);
            },
        },
        components: {}
    }
</script>
